package com.liang.dao;

import com.liang.entity.PrjProject;
import com.liang.entity.StaFeasibilityreport;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (StaFeasibilityreport)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-03 23:38:21
 */
public interface StaFeasibilityreportDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaFeasibilityreport queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staFeasibilityreport 查询条件
     * @param pageable             分页对象
     * @return 对象列表
     */
    List<StaFeasibilityreport> queryAllByLimit(StaFeasibilityreport staFeasibilityreport, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staFeasibilityreport 查询条件
     * @return 总行数
     */
    long count(StaFeasibilityreport staFeasibilityreport);

    /**
     * 新增数据
     *
     * @param staFeasibilityreport 实例对象
     * @return 影响行数
     */
    int insert(StaFeasibilityreport staFeasibilityreport);

    /**
     * 撤销数据（基本信息）
     *
     * @param staFeasibilityreport 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(StaFeasibilityreport staFeasibilityreport);

    /**
     * 新增数据(基本数据)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int insertNormal(StaFeasibilityreport staFeasibilityreport);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaFeasibilityreport> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaFeasibilityreport> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaFeasibilityreport> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaFeasibilityreport> entities);

    /**
     * 修改数据
     *
     * @param staFeasibilityreport 实例对象
     * @return 影响行数
     */
    int update(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(基本信息)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateNormal(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(目的和意义)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateMdhyy(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(研究水平)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateYjsp(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(理论实践依据)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateLlsjyj(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(研究内容)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateYjnr(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(经济性财务合规性)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateJjxcwhgx(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(预期目标)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateYqmb(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(合作单位)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateHzdw(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(承担单位条件)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateCddw(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(审查意见)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateScyj(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(附件)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateFj(StaFeasibilityreport staFeasibilityreport);

    /**
     * 修改数据(签名盖章)
     *
     * @param staFeasibilityreport 实例对象
     * @return 实例对象
     */
    int updateQmgz(StaFeasibilityreport staFeasibilityreport);

    /**
     * 通过主键删除数据
     *
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<StaFeasibilityreport> getReportInfoList(Map map);

    /**
     * 根据项目类型获取科研报告
     *
     * @param map
     * @return
     */
    List<StaFeasibilityreport> getRwsKybgList(Map map);

    /**
     * 修改审批状态
     *
     * @param project
     * @return
     */
    int updateSpzt(StaFeasibilityreport project);
}

